package com.sky.ioc.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.sky.ioc.entity.domain.parking.Park;
import com.sky.ioc.entity.params.IocParam;
import com.sky.ioc.entity.params.IocTimeRange;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

@Mapper
public interface ParkMapper extends BaseMapper<Park> {
    @Select("<script>" +
            "SELECT count(1) FROM park where 1=1 " +
            "<if test='iocParam!=null and iocParam.companyId != null '>" +
            " and company_id=#{iocParam.companyId} " +
            "</if>"+
            "<if test='iocParam!=null and iocParam.timeRange != null '>" +
            "<![CDATA[ and entrytime > #{iocParam.timeRange.startDate} " +
            " and  departuretime < #{iocParam.timeRange.endDate} ]]>" +

            "</if>"+
            "</script>")
    Integer getTotalParkByCompanyIdAndDeptId(@Param("iocParam") IocParam iocParam);

    @Select("<script>" +
            "SELECT count(1) FROM park where 1=1 " +
            "<if test='iocParam!=null and iocParam.companyId != null '>" +
            " and company_id=#{iocParam.companyId} " +
            "</if>"+
            "<if test='iocParam!=null and iocParam.timeRange != null '>" +
            " <![CDATA[ and entrytime > #{iocParam.timeRange.startDate} and entrytime < #{iocParam.timeRange.endDate} ]]> " +
            "</if>"+
            "</script>")
    Integer getTotalParkByCompanyIdAndDeptIdAndEntryTime(@Param("iocParam") IocParam iocParam);

    @Select("<script>" +
            "SELECT count(1) FROM park where 1=1 " +
            "<if test='iocParam!=null and iocParam.companyId != null '>" +
            " and company_id=#{iocParam.companyId} " +
            "</if>"+
            "<if test='iocParam!=null '>" +
            " <![CDATA[ and departuretime > #{iocParam.timeRange.startDate} and departuretime < #{iocParam.timeRange.endDate} ]]>" +
            "</if>"+
            "</script>")
    Integer getTotalParkByCompanyIdAndDeptIdAndDepartureTime(@Param("iocParam") IocParam iocParam);

    @Select("<script>" +
            "SELECT count(1) FROM park where 1=1 " +
            "<if test='iocParam!=null and iocParam.companyId != null '>" +
            " and company_id=#{iocParam.companyId} " +
            "</if>"+
            "<if test='iocParam!=null and iocParam.timeRange != null '>" +
            " <![CDATA[ and entrytime > #{iocParam.timeRange.startDate} and departuretime < #{iocParam.timeRange.endDate} ]]>" +
            "</if>"+
            "<if test='type!=null  '>" +
            " and type=#{type} " +
            "</if>"+
            "</script>")
    Integer getTotalParkByCompanyIdAndDeptIdAndType(@Param("iocParam") IocParam iocParam,@Param("type")Integer type);

    @Select("<script>" +
            "SELECT company,count(1) as total  FROM park where 1=1 " +
            "<if test='iocParam!=null and iocParam.companyId != null '>" +
            " and company_id=#{iocParam.companyId} " +
            "</if>"+
            "<if test='iocParam!=null and iocParam.timeRange != null '>" +
            " <![CDATA[ and entrytime > #{iocParam.timeRange.startDate} and departuretime < #{iocParam.timeRange.endDate} ]]>" +
            "</if>"+
            "<if test='type!=null  '>" +
            " and type=#{type} " +
            "</if>"+
            " GROUP BY company_id,company " +
            "</script>")
    List<Map<String,String>> getListByCompanyIdAndDeptIdAndType(@Param("iocParam") IocParam iocParam, @Param("type")Integer type);

}
