package com.sky.ioc.service.Parking.impl;

import com.sky.ioc.entity.domain.parking.Park;
import com.sky.ioc.entity.domain.parking.Parking;
import com.sky.ioc.mapper.ParkMapper;
import com.sky.ioc.mapper.job.TokenMapper;
import com.sky.ioc.service.Parking.ParkService;
import com.sky.ioc.tool.ReturnMsg;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.concurrent.ThreadLocalRandom;

@Service
@Slf4j
public class ParkServiceImpl implements ParkService {

    @Autowired
    TokenMapper tokenMapper;

    @Value("${sky.dataIp}")
    private String dataIp;

    @Autowired
    ParkMapper parkMapper;

    final static  String PARK_URL="%s/api/parking/PARKING/parkingDuration/list";

    @Override
    public ReturnMsg getParkData() {
        String url =   String.format(PARK_URL,"http://"+dataIp)+"??pageNum=1&pageSize=1000";
        Map<String,String> tokenMap = tokenMapper.getNewToken();
        String token ="Bearer eyJhbGciOiJIUzUxMiJ9.eyJ1c2VyX2lkIjoxLCJ1c2VyX2tleSI6IjUwZTU1NTRkLWJjYzYtNGRhMS1iZDUxLWFhNTc3YzU4YTFiNCIsInVzZXJuYW1lIjoiYWRtaW4ifQ.X10VPYJfeeRTka7OtqNPOGMpL4QkW3fR_TfCKXCmO-yXbIIrr_40fcwiVnpXfYVENo_BvXWEACRd-Y6nXsbkog";
        if(tokenMap!=null){
            token = "Bearer "+tokenMap.get("token");
        }
        // 创建一个请求头对象
        HttpHeaders httpHeaders = new HttpHeaders();
        // 设置参数
        httpHeaders.set("authorization", token);
        // 创建一个响应体对象
        HttpEntity<String> httpEntity = new HttpEntity(httpHeaders);
        // 3.创建RestTemplate
        RestTemplate restTemplate = new RestTemplate();
        // 发送GET请求
        ResponseEntity<Map> responseEntity = restTemplate.exchange(url, HttpMethod.GET, httpEntity, Map.class);
        // 获取响应对象里的 body 对象
        Map<String, Object> body = responseEntity.getBody();
        // 获取状态码
        Integer code = (Integer)body.get("code");
        // 获取响应信息
        String message = (String)body.get("msg");
        if(code==200){
            ThreadLocalRandom random = ThreadLocalRandom.current();
            ArrayList list = (ArrayList) body.get("rows");
            if(list!=null&&list.size()>0){
                parkMapper.delete(null);
                for (int i=0;i<list.size();i++){
                    LinkedHashMap json = (LinkedHashMap) list.get(i);
                    Park park = new Park();
                    park.setId((Integer) json.get("id"));
                    park.setParkingNumbers(String.valueOf(json.get("parkingNumbers")));
                    park.setEntryTime(String.valueOf(json.get("inParkTime")));
                    park.setLicencePlate(String.valueOf(json.get("illegalCardnumber")));
                    park.setDepartureTime(String.valueOf(json.get("outParkTime")));
                    park.setType(Integer.parseInt(String.valueOf(json.get("ifIllegal"))));
                    parkMapper.insert(park);
                }
            }
            return ReturnMsg.ok();
        }else{
            log.info("获取车位数据："+message);
            return  ReturnMsg.fail(message);
        }
    }
}
